import pytest


def test_001_i_want_to_log_statistics_samples_for_concept_ids_1_and_2_at_adml(admlc):

  requestBody = { "list":"1,2" }
  responseBodyRef = { "success":"true", "response":"Log statistics samples for '1,2' concepts" }

  # Send POST
  response = admlc.postDict("/log-statistics-samples", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

def test_002_i_want_to_disable_log_statistics_samples_at_adml(admlc):

  requestBody = { "list":"none" }
  responseBodyRef = { "success":"true", "response":"Log statistics samples for 'none' concepts" }

  # Send POST
  response = admlc.postDict("/log-statistics-samples", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)

def test_003_i_want_to_enable_log_statistics_samples_for_every_concept_id_registered_at_adml(admlc):

  requestBody = { "list":"all" }
  responseBodyRef = { "success":"true", "response":"Log statistics samples for 'all' concepts" }

  # Send POST
  response = admlc.postDict("/log-statistics-samples", requestBody)

  # Verify response
  admlc.assert_response__status_body_headers(response, 200, responseBodyRef)
