// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/app/functions.hpp>

#include <anna/comm/ClientSocket.hpp>
#include <anna/comm/Communicator.hpp>

#include <anna/http/Response.hpp>

#include "Transaction.hpp"

using namespace std;
using namespace anna;
using namespace test;

http4comm::Transaction::Transaction () : 
   a_clientSocket (NULL) 
{ 
   a_httpResponse = new http::Response;
}

/**
 * Si el servidor aritmtico no contesta antes de que se cumpla el tiempo de espera
 * de la transacin se contesta al cliente con un error indicando la situacin.
 */
void http4comm::Transaction::expire (anna::timex::Engine*)
   throw (RuntimeException)
{
    comm::Communicator* communicator = app::functions::component <comm::Communicator> (ANNA_FILE_LOCATION);

    comm::ClientSocket* clientSocket = getClientSocket ();

    if (communicator->isUsable (clientSocket) == false)
       return;

    a_httpResponse->setStatusCode (408);
    a_httpResponse->clearBody ();

    clientSocket->send (a_httpResponse);
}

 
