// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_core_hpp
#define anna_core_core_hpp

/**
Proporciona las clases y patrones de desarrollo b�sico, que podr�an ser utilizados por cualquier
aplicaci�n y/o plataforma.

El ejecutable deber� enlazarse con la librer�a: libanna.core.a

El <b>Packet Header</b> es anna.h

\warning Este archivo deberia cargarse unica y exclusivamente desde un fuente C++, nunca debe
         cargarse desde un header.
*/
namespace anna {}


#include <anna/core/Allocator.hpp>
#include <anna/core/AutoPointer.hpp>
#include <anna/core/Cloneable.hpp>
#include <anna/core/util/Configuration.hpp>
#include <anna/core/define.autoenum.hpp>
#include <anna/core/Exception.hpp>
#include <anna/core/functions.hpp>
#include <anna/core/RuntimeException.hpp>
#include <anna/core/Singleton.hpp>
#include <anna/core/internal/ModuleManager.hpp>
#include <anna/core/internal/sccs.hpp>
#include <anna/core/mt/Guard.hpp>
#include <anna/core/mt/Mutex.hpp>
#include <anna/core/mt/NRMutex.hpp>
#include <anna/core/mt/Resource.hpp>
#include <anna/core/mt/Runnable.hpp>
#include <anna/core/mt/Safe.hpp>
#include <anna/core/mt/SafeRecycler.hpp>
#include <anna/core/mt/SafeSortedVector.hpp>
#include <anna/core/mt/Semaphore.hpp>
#include <anna/core/mt/ThreadData.hpp>
#include <anna/core/mt/Thread.hpp>
#include <anna/core/mt/ThreadManager.hpp>
#include <anna/core/oam/Configuration.hpp>
#include <anna/core/oam/defines.hpp>
#include <anna/core/oam/Handler.hpp>
#include <anna/core/oam/Module.hpp>
#include <anna/core/oam/Counter.hpp>
#include <anna/core/oam/CounterRecorder.hpp>
#include <anna/core/oam/CounterScope.hpp>
#include <anna/core/tracing/Configuration.hpp>
#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceFunction.hpp>
#include <anna/core/tracing/TraceLevelChecker.hpp>
#include <anna/core/tracing/TraceLogger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/core/tracing/TraceWriter.hpp>
#include <anna/core/tracing/TraceWriterObserver.hpp>
#include <anna/core/util/Average.hpp>
#include <anna/core/util/CommandLine.hpp>
#include <anna/core/util/CommaSeparatedList.hpp>
#include <anna/core/util/Component.hpp>
#include <anna/core/util/ComponentManager.hpp>
#include <anna/core//DataBlock.hpp>
#include <anna/core/util/defines.hpp>
#include <anna/core/util/DelayMeter.hpp>
#include <anna/core/util/EqualTo.hpp>
#include <anna/core/util/ExclusiveHash.hpp>
#include <anna/core/util/LRUMap.hpp>
#include <anna/core/util/Microsecond.hpp>
#include <anna/core/util/Millisecond.hpp>
#include <anna/core/util/MultiMap.hpp>
#include <anna/core/util/MultiRangeExpression.hpp>
#include <anna/core/util/Recycler.hpp>
#include <anna/core/util/RegularExpression.hpp>
#include <anna/core/util/Second.hpp>
#include <anna/core/util/SortedVector.hpp>
#include <anna/core/util/String.hpp>
#include <anna/core/util/Tokenizer.hpp>
#include <anna/core/util/Variable.hpp>
#include <anna/core/util/ZBlock.hpp>

using namespace anna;

#endif
