// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_comm_ClientSessionReceiver_hpp
#define anna_diameter_comm_ClientSessionReceiver_hpp

#include <anna/comm/Receiver.hpp>
#include <anna/core/RuntimeException.hpp>


namespace anna {
namespace comm {
class Message;
class ClientSocket;
class Server;
}
}


namespace anna {

namespace diameter {

namespace comm {


class ClientSession;


class ClientSessionReceiver : public anna::comm::Receiver {
public:
  virtual ~ClientSessionReceiver() {;}

  static const char* className() throw() { return "diameter.comm.ClientSessionReceiver"; }
  void setReference(ClientSession *s) throw() { a_session = s; }

  // base class virtuals
  void eventBreakConnection(const anna::comm::ClientSocket&) throw();
  void eventCreateConnection(const anna::comm::Server*) throw();

private:
  ClientSessionReceiver() : anna::comm::Receiver("diameter.comm.ClientSessionReceiver") { a_session = NULL; }
  void initialize() throw(anna::RuntimeException) {;}
  void apply(anna::comm::ClientSocket&, const anna::comm::Message&) throw(anna::RuntimeException);


  anna::diameter::comm::ClientSession *a_session;

  friend class anna::Allocator <ClientSessionReceiver>;
};


}
}
}

#endif

