// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/comm/Message.hpp>

#include <anna/xml/Compiler.hpp>

using namespace anna;

comm::Message::Message() :
  DataBlock(true),
  a_xmlCompiler(NULL),
  a_statusCodeBuffer(StatusCodeBuffer::None),
  a_codeBuffer(NULL) {
}

// explicit
comm::Message::Message(const comm::Message::StatusCodeBuffer::_v statusCodeBuffer) :
  DataBlock(true),
  a_xmlCompiler(NULL),
  a_statusCodeBuffer(statusCodeBuffer) {
  if(statusCodeBuffer == StatusCodeBuffer::Reserve)
    a_codeBuffer = new DataBlock(true);
  else
    a_codeBuffer = NULL;
}

// explicit
comm::Message::Message(DataBlock& codeBuffer) :
  DataBlock(true),
  a_xmlCompiler(NULL),
  a_statusCodeBuffer(StatusCodeBuffer::Copy) {
  a_codeBuffer = &codeBuffer;
}

/*virtual*/
comm::Message::~Message() {
  if(a_statusCodeBuffer == StatusCodeBuffer::Reserve)
    delete a_codeBuffer;

  delete a_xmlCompiler;
}

/*
 * (1) Si NO tiene activado el indicador de copia profunda => tenemos que ubicar la memoria; que tiene que estar disponible
 * hasta el momento en que se invoca al mtodo de Message::code.
 */
/*virtual*/
comm::Message * comm::Message::setBody(const xml::Node* node)
throw(RuntimeException) {
  if(a_xmlCompiler == NULL)
    a_xmlCompiler = new xml::Compiler;

  const char* xmldoc = a_xmlCompiler->apply(node, xml::Compiler::Mode::Compact);
  setBody(xmldoc, anna_strlen(xmldoc));
  return this;
}


