// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


// Local
#include <anna/diameter/helpers/tme/codectypes/ISDNAddress.hpp>


//------------------------------------------------------------------------------
//---------------------------------------------------- ISDNAddress::updateBasic()
//------------------------------------------------------------------------------
void anna::diameter::helpers::tme::codectypes::ISDNAddress::updateBasic() throw(anna::RuntimeException) {
  std::string result;
  anna::functions::codeIsupNumber(a_isupNumber, true /* called party number */, result);
  OctetString::setValue(result);
}


//------------------------------------------------------------------------------
//--------------------------------------------------------- ISDNAddress::decode()
//------------------------------------------------------------------------------
void anna::diameter::helpers::tme::codectypes::ISDNAddress::decode(const char* buffer, const int size) throw(anna::RuntimeException) {
  if(!buffer)
    throw anna::RuntimeException("ISDNAddress::decode | Null Buffer provided", ANNA_FILE_LOCATION);

  if(size < 2)
    throw anna::RuntimeException("ISDNAddress::decode | Buffer length must have at least 2 bytes", ANNA_FILE_LOCATION);

  anna::functions::decodeIsupNumber(buffer, size, a_isupNumber, true /* called party number */);
  // Base class decode()
  OctetString::decode(buffer, size);
}
